% Module unif (signature file)
%
% Copyright (C) 2003 Alwen Tiu
%
%   This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or (at
% your option) any later version.
% 
%   This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

% Module:  Huet's Unification Algorithm
% Author:  Alwen Tiu
% Date:    11/30/01, 8/26/03

sig unif.

accum_sig lincsig.


kind spair type.
kind node type.

type pair tm -> tm -> spair. % substitution pair.
type subst list signat -> list spair -> tm -> tm -> o. % substitution.


% unify Lvars T1 T2 Subs
% Lvars contains all the free variables occuring in T1 and T2.
% Subs is the unifier.
type unify defn -> list signat -> list signat -> tm -> tm -> node -> list (list spair) -> o. 

type fail_node node.
type succ_node node.
type flex_node node.
type n_node    list spair -> node.

